Page MenuHomePhabricator

Dataset of book editions cited by ISBN in Wikipedia
Closed, ResolvedPublic

Description

The Internet Archive is interested in creating a wishlist of books to prioritize for digitization and they reached out to ask if we have data of ISBNs cited in WIkipedia.

Back in 2015 @Halfak and I worked on this dataset which hasn't been refreshed since then.

The goal of this task is to publish a fresh snapshot of this data using the mwcites utility and potentially expand the dataset to some of the largest language editions by article count, other than EN (i.e. FR, SV, DE, NL, RU, IT, ES, not including bulk populated editions such as Cebuano).

Event Timeline

Restricted Application added a project: Internet-Archive. · View Herald TranscriptJan 10 2018, 8:55 PM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
DarTar triaged this task as Low priority.Jan 10 2018, 8:55 PM

@bmansurov we can upload a copy of the data to the public datasets folder maintained by Analytics and also upload it to the figshare entry here (I can take care of the latter).

@DarTar the latest bz2 dumps seem te be from December 1, 2017. Below is the list for enwiki. Is it good for our purposes, or do we want the January dumps to be ready?

@bmansurov the most recent is perfect.

I'd add AR to the list due to the high number of global Arabic speakers.

bmansurov added a comment.EditedJan 10 2018, 10:58 PM

@bmansurov the most recent is perfect.

OK. Just a heads up that enwiki alone has over 800GB of data and the download servers have speed limits. I'll upload the results as the downloads finish.

DarTar updated the task description. (Show Details)Jan 12 2018, 8:02 PM
DarTar awarded a token.

@DarTar the enwiki results are also up (the links will appear in the above url shortly). Please let me know if you need other languages too.

@bmansurov fantastic. The EN and ES datasets are more than we needed for the Archive’s wishlist (they needed it by Monday). I would still like to complete the other languages and announce the refreshed datasets but this is not time sensitive. Thanks for checking in over the weekend!

@bmansurov I spot-checked some of the files and came across a few issues.

  1. the filtered datasets seem to have a spurious line number at the beginning of each row:
2:1092924       Jára Cimrman    96864628        2013-09-21T19:14:42Z    isbn    2296493173
3:17416 Bacilly 121685300       2015-12-28T17:38:04Z    isbn    9782354580360
4:3     Antoine Meillet 83516779        2012-09-29T17:06:10Z    isbn    9789042917439
5:3     Antoine Meillet 12397397        2006-12-08T21:39:50Z    isbn    2252018712
6:1425306       K-219   108731662       2014-11-01T13:18:59Z    isbn    9780465051854

This seems like an easy fix.

  1. there seem to be occasionally invalid values, for example the following articles from frwiki each have one spurious record with a 2-digit ISBNs:
6:1425306	K-219	108731662	2014-11-01T13:18:59Z	isbn	9780465051854
7:1425306	K-219	108731662	2014-11-01T13:18:59Z	isbn	2258048907
8:1425306	K-219	108731662	2014-11-01T13:18:59Z	isbn	10	<--------
9:1425306	K-219	108731662	2014-11-01T13:18:59Z	isbn	9788125024774
11:321445	Châteauneuf-Villevieille	49417636	2010-01-30T14:24:29Z	isbn	284234071X
12:321445	Châteauneuf-Villevieille	83778617	2012-10-06T07:58:59Z	isbn	2	<--------
13:321445	Châteauneuf-Villevieille	83843475	2012-10-07T16:41:20Z	isbn	2864101173
14:321445	Châteauneuf-Villevieille	49478492	2010-02-01T09:37:36Z	isbn	2865350703

I checked the corresponding revids:

  • for K-219 (108731662), this seems to be caused by a parameter erroneously typed as isbn 10=0-09-926966-X (instead of isbn10=0-09-926966-X)
  • for Châteauneuf-Villevieille ( 83778617) this seems to be a missing hyphen in the ISBN value: isbn=2 906700-09-6 (instead of isbn=2-906700-09-6)

I think it's fine to leave these values in the dataset (since we don't validate these values against an ISBN validator), when these are mistakes made by editors, but we should add a note to data consumers.

Aside from errors made by contributors, I also hadn't anticipated that some languages have extremely complex parameter schemas for representing something relatively straightforward IDs such as an ISBN, see for example French Wikipedia's https://fr.wikipedia.org/wiki/Modèle:Ouvrage which allows the following: isbn= |isbn2= |isbn3= |isbn erroné=

cc'ing @Halfak for visibility

@DarTar the first issue has been fixed. I've left a note in README.txt about the second issue. Let me know if you want to change the wording.

@DarTar the first issue has been fixed.

Perfect

I've left a note in README.txt about the second issue. Let me know if you want to change the wording.

I’d say simply: “Please note that these datasets represent a record of identifiers as added by Wikipedia contributors, aiming to provide a complete historical record of article revisions. Because of this, some identifiers included in the dataset may not be valid.”

README.txt has been updated. The citations for the following languages have been generated: ar, de, en, es, fr, it, nl, ru, sv.

bmansurov closed this task as Resolved.Feb 26 2018, 7:25 PM

@bmansurov I had a quick chat with @Halfak about mwcites today and he was asking me if:

  • you were considering submitting the most recent patches we discussed as PRs
  • you'd be interested in taking on the ownership of the library

What do you think? Aaron is not expecting to allocate much more work to this in the future, but it sounds like we might.

@DarTar I already made a pull request. Sure, I can take ownership of mwcites. I may as well transfer it to the Wikimedia Github account and do the future development there.

@Halfak, my Github username is kodchi. Thanks.

Halfak added a comment.Mar 8 2018, 3:57 PM

Aha! I didn't realize that was you :)

@bmansurov perfect. And on a related note, are you in the process of refreshing the data after working on a patch? It just occurred to me we haven't confirmed plans/dates for a potential refresh.

@Halfak pseudonymity broken :)

@DarTar, not quite. Theoretically the fix should work. But I'm running the script against frwiki in order to test the patch in practice as Aaron suggested. Once we confirm that it fixes more ISBNs than it breaks, then we can discuss the dates for refresh.

@bmansurov sounds good, thank you!

(cc @Ocaasi_WMF @BVershbow_WMF for visibility)

bmansurov added a comment.EditedMar 19 2018, 2:21 AM

Status update: I've generated citation data for 194 wikis. 103 more to go. Here's the list of wikis that are completed. I have uplodaed the files we have so far to https://analytics.wikimedia.org/datasets/archive/public-datasets/all/mwrefs/mwcites-20180301/. I'll upload the remaining ones once they are ready.

aawiki
abwiki
acewiki
adywiki
afwiki
akwiki
alswiki
amwiki
angwiki
anwiki
arcwiki
arwiki
arzwiki
astwiki
aswiki
atjwiki
avwiki
aywiki
azbwiki
azwiki
barwiki
bat_smgwiki
bawiki
bclwiki
bewiki
be_x_oldwiki
bgwiki
bhwiki
biwiki
bjnwiki
bmwiki
bnwiki
bowiki
bpywiki
brwiki
bswiki
bugwiki
bxrwiki
cawiki
cbk_zamwiki
cdowiki
cebwiki
cewiki
chowiki
chrwiki
chwiki
chywiki
ckbwiki
cowiki
crhwiki
crwiki
csbwiki
cswiki
dawiki
dewiki
dinwiki
diqwiki
dsbwiki
dtywiki
dvwiki
dzwiki
eewiki
elwiki
emlwiki
enwiki
eowiki
eswiki
iawiki
idwiki
iewiki
igwiki
iiwiki
ikwiki
ilowiki
iowiki
iswiki
itwiki
iuwiki
jamwiki
jawiki
jbowiki
jvwiki
kaawiki
kabwiki
kawiki
kbdwiki
kbpwiki
kgwiki
kiwiki
kjwiki
kkwiki
klwiki
kmwiki
knwiki
koiwiki
kowiki
krcwiki
krwiki
kshwiki
kswiki
kuwiki
kvwiki
kwwiki
kywiki
ladwiki
lawiki
lbewiki
lbwiki
lezwiki
lgwiki
lijwiki
liwiki
lmowiki
lnwiki
lowiki
lrcwiki
ltgwiki
ltwiki
lvwiki
maiwiki
map_bmswiki
mdfwiki
mgwiki
mhrwiki
mhwiki
minwiki
miwiki
mkwiki
mlwiki
mnwiki
mrjwiki
mrwiki
mswiki
mtwiki
muswiki
mwlwiki
myvwiki
mywiki
mznwiki
nahwiki
napwiki
nawiki
nds_nlwiki
ndswiki
newiki
newwiki
ngwiki
nlwiki
nnwiki
novwiki
nowiki
nrmwiki
nsowiki
nvwiki
nywiki
ocwiki
olowiki
omwiki
orwiki
oswiki
pagwiki
pamwiki
papwiki
pawiki
pcdwiki
pdcwiki
pflwiki
pihwiki
piwiki
plwiki
pmswiki
pnbwiki
pntwiki
pswiki
ptwiki
quwiki
rmwiki
rmywiki
rnwiki
roa_rupwiki
roa_tarawiki
rowiki
ruewiki
ruwiki
rwwiki
sahwiki
sawiki
scnwiki
scowiki
scwiki
sdwiki
sewiki
sgwiki
shwiki

All 10 wikis (among the other ones) for @Miriam's analysis are ready. I'll upload the remaining wikis for the announcement as they become ready.

I've uploaded citations (and ISBN only) data for every wiki to https://analytics.wikimedia.org/datasets/archive/public-datasets/all/mwrefs/mwcites-20180301/. The files will show up there shortly (~30mins).

bmansurov added a comment.EditedMar 23 2018, 3:18 PM

Here's the number of lines (the numbers include the header) generated by mwcites. Some (many?) of the lines contain empty citations. I haven't done any data checking or cleaning.

|        7 | biwiki.tsv           |
|       92 | tkwiki.tsv           |
|      215 | xhwiki.tsv           |
|     3308 | anwiki.tsv           |
|   111396 | glwiki.tsv           |
|     8680 | scowiki.tsv          |
|    55534 | dawiki.tsv           |
|   225055 | ukwiki.tsv           |
|       68 | cdowiki.tsv          |
|      674 | sawiki.tsv           |
|      676 | ruewiki.tsv          |
|      995 | lowiki.tsv           |
|      239 | kwwiki.tsv           |
|       49 | nahwiki.tsv          |
|    28784 | etwiki.tsv           |
|      174 | aywiki.tsv           |
|      148 | akwiki.tsv           |
|        1 | tenwiki.tsv          |
|        1 | adywiki.tsv          |
|     7257 | minwiki.tsv          |
|    16841 | warwiki.tsv          |
|       65 | papwiki.tsv          |
|       27 | pdcwiki.tsv          |
|        4 | bugwiki.tsv          |
|     9755 | bawiki.tsv           |
|    30325 | lawiki.tsv           |
|       12 | jbowiki.tsv          |
|        2 | atjwiki.tsv          |
|      427 | scnwiki.tsv          |
|  1064610 | svwiki.tsv           |
|        1 | mhwiki.tsv           |
|      106 | bpywiki.tsv          |
|      498 | iowiki.tsv           |
|     1159 | xmfwiki.tsv          |
|        9 | gotwiki.tsv          |
|      688 | hifwiki.tsv          |
|  1897669 | cebwiki.tsv          |
|        1 | dinwiki.tsv          |
|     3552 | mnwiki.tsv           |
|      113 | oswiki.tsv           |
|    34953 | bewiki.tsv           |
|       16 | nrmwiki.tsv          |
|    63615 | huwiki.tsv           |
|    31677 | skwiki.tsv           |
|    92636 | kowiki.tsv           |
|      234 | napwiki.tsv          |
|   125843 | nowiki.tsv           |
|       65 | nvwiki.tsv           |
|      366 | amwiki.tsv           |
|      557 | maiwiki.tsv          |
|     5550 | be_x_oldwiki.tsv     |
|       22 | dvwiki.tsv           |
|      471 | gomwiki.tsv          |
|      373 | mhrwiki.tsv          |
|      520 | gnwiki.tsv           |
|    27669 | alswiki.tsv          |
|      226 | zh_classicalwiki.tsv |
|      839 | diqwiki.tsv          |
|       18 | glkwiki.tsv          |
|    21335 | kawiki.tsv           |
|     2457 | pamwiki.tsv          |
|        1 | cawiki.tsv           |
|      632 | jamwiki.tsv          |
|      750 | myvwiki.tsv          |
|     1093 | ckbwiki.tsv          |
|    15448 | azwiki.tsv           |
|   487934 | itwiki.tsv           |
|    27313 | nnwiki.tsv           |
|     8840 | lbwiki.tsv           |
|   147007 | srwiki.tsv           |
|     1159 | gvwiki.tsv           |
|       21 | nawiki.tsv           |
|   172248 | cswiki.tsv           |
|       12 | crhwiki.tsv          |
|   155062 | arwiki.tsv           |
|   299830 | ptwiki.tsv           |
|      526 | sowiki.tsv           |
|     2345 | mwlwiki.tsv          |
|        4 | dzwiki.tsv           |
|        6 | bmwiki.tsv           |
|      173 | vowiki.tsv           |
|    30536 | mkwiki.tsv           |
|       67 | frrwiki.tsv          |
|      327 | wawiki.tsv           |
|      153 | sdwiki.tsv           |
|    13343 | orwiki.tsv           |
|       80 | tnwiki.tsv           |
|       63 | dtywiki.tsv          |
|       59 | zawiki.tsv           |
|      995 | dsbwiki.tsv          |
|       18 | tpiwiki.tsv          |
|      545 | wuuwiki.tsv          |
|        1 | ikwiki.tsv           |
|    11471 | euwiki.tsv           |
|       11 | klwiki.tsv           |
|        1 | krwiki.tsv           |
|    21540 | knwiki.tsv           |
|       93 | xalwiki.tsv          |
|   360909 | zhwiki.tsv           |
|      108 | towiki.tsv           |
|        1 | aawiki.tsv           |
|    20042 | cywiki.tsv           |
|     2252 | tgwiki.tsv           |
|       17 | roa_rupwiki.tsv      |
|      964 | iawiki.tsv           |
|     1234 | bhwiki.tsv           |
|     5222 | kmwiki.tsv           |
|      264 | bjnwiki.tsv          |
|       64 | wowiki.tsv           |
|       25 | novwiki.tsv          |
|     2596 | rmwiki.tsv           |
|     1192 | mtwiki.tsv           |
|    54526 | hywiki.tsv           |
|        5 | twwiki.tsv           |
|    52440 | eowiki.tsv           |
|     3389 | hsbwiki.tsv          |
|     7238 | jvwiki.tsv           |
|   117554 | nlwiki.tsv           |
|       13 | pagwiki.tsv          |
|     3358 | ilowiki.tsv          |
|   522142 | frwiki.tsv           |
|        8 | rnwiki.tsv           |
|        2 | tywiki.tsv           |
|     1580 | koiwiki.tsv          |
|        1 | iuwiki.tsv           |
|        6 | smwiki.tsv           |
|   167208 | fiwiki.tsv           |
|    67564 | trwiki.tsv           |
|    31343 | simplewiki.tsv       |
|        1 | kjwiki.tsv           |
|       25 | frpwiki.tsv          |
|       23 | mdfwiki.tsv          |
|      844 | bxrwiki.tsv          |
|       69 | kabwiki.tsv          |
|    62330 | bgwiki.tsv           |
|      142 | stwiki.tsv           |
|        3 | crwiki.tsv           |
|     3656 | mywiki.tsv           |
|      213 | igwiki.tsv           |
|      161 | zeawiki.tsv          |
|      745 | lmowiki.tsv          |
|        1 | chowiki.tsv          |
|      401 | stqwiki.tsv          |
|     1178 | quwiki.tsv           |
|      326 | mgwiki.tsv           |
|        1 | muswiki.tsv          |
|      130 | nsowiki.tsv          |
|      258 | ganwiki.tsv          |
|    20580 | tewiki.tsv           |
|       52 | tcywiki.tsv          |
|      458 | pcdwiki.tsv          |
|       47 | kbdwiki.tsv          |
|       34 | udmwiki.tsv          |
|        8 | vewiki.tsv           |
|     3921 | zh_yuewiki.tsv       |
|     6528 | brwiki.tsv           |
|  1648869 | dewiki.tsv           |
|       63 | bat_smgwiki.tsv      |
|     3264 | cvwiki.tsv           |
|       78 | tiwiki.tsv           |
|       17 | pntwiki.tsv          |
|   140850 | viwiki.tsv           |
|        5 | kgwiki.tsv           |
|        1 | chywiki.tsv          |
|        1 | hzwiki.tsv           |
|       36 | cuwiki.tsv           |
|      444 | mznwiki.tsv          |
|       59 | hawiki.tsv           |
|    53678 | thwiki.tsv           |
|      172 | sswiki.tsv           |
|     4199 | suwiki.tsv           |
|     6577 | aswiki.tsv           |
|   335879 | plwiki.tsv           |
|        9 | abwiki.tsv           |
|    33335 | kywiki.tsv           |
|   603958 | eswiki.tsv           |
|    15973 | swwiki.tsv           |
|     1442 | mrwiki.tsv           |
|        1 | ffwiki.tsv           |
|      147 | miwiki.tsv           |
|      106 | acewiki.tsv          |
|        7 | hawwiki.tsv          |
|     1519 | gdwiki.tsv           |
|      186 | pmswiki.tsv          |
|      116 | bowiki.tsv           |
|      191 | cowiki.tsv           |
|       58 | rwwiki.tsv           |
|        2 | tumwiki.tsv          |
|        6 | chwiki.tsv           |
|      157 | lijwiki.tsv          |
|        8 | srnwiki.tsv          |
|     8650 | guwiki.tsv           |
|      566 | htwiki.tsv           |
|      124 | cbk_zamwiki.tsv      |
|       80 | avwiki.tsv           |
|     4064 | ocwiki.tsv           |
|     1016 | uzwiki.tsv           |
|        8 | gagwiki.tsv          |
|     2083 | gawiki.tsv           |
|   589376 | jawiki.tsv           |
|      869 | azbwiki.tsv          |
|     2592 | pnbwiki.tsv          |
|    59788 | kkwiki.tsv           |
|     2811 | testwiki.tsv         |
|        4 | pihwiki.tsv          |
|        2 | fjwiki.tsv           |
|       42 | furwiki.tsv          |
|      294 | ladwiki.tsv          |
|      274 | kshwiki.tsv          |
|     3804 | ttwiki.tsv           |
|     1909 | newiki.tsv           |
|      908 | zh_min_nanwiki.tsv   |
|    12472 | barwiki.tsv          |
|        1 | hewiki.tsv           |
|        1 | howiki.tsv           |
|      406 | map_bmswiki.tsv      |
|      414 | scwiki.tsv           |
|      295 | vlswiki.tsv          |
|   157134 | shwiki.tsv           |
|    10779 | tlwiki.tsv           |
|    52352 | slwiki.tsv           |
|       58 | tetwiki.tsv          |
|    20504 | ltwiki.tsv           |
|      496 | roa_tarawiki.tsv     |
|      194 | csbwiki.tsv          |
|      311 | lezwiki.tsv          |
|      616 | lnwiki.tsv           |
|      347 | extwiki.tsv          |
|      145 | angwiki.tsv          |
|      713 | pswiki.tsv           |
|        5 | kbpwiki.tsv          |
|      307 | pflwiki.tsv          |
|       19 | ugwiki.tsv           |
|     7677 | pawiki.tsv           |
|       95 | ltgwiki.tsv          |
|       31 | fiu_vrowiki.tsv      |
|      630 | arzwiki.tsv          |
|      215 | liwiki.tsv           |
|    11320 | sqwiki.tsv           |
|        7 | kiwiki.tsv           |
|      187 | olowiki.tsv          |
|  3794696 | enwiki.tsv           |
|      232 | nds_nlwiki.tsv       |
|     1787 | yowiki.tsv           |
|       85 | mrjwiki.tsv          |
|        8 | piwiki.tsv           |
|     7203 | siwiki.tsv           |
|       72 | eewiki.tsv           |
|    48006 | mswiki.tsv           |
|    80846 | elwiki.tsv           |
|   140450 | idwiki.tsv           |
|     6038 | lvwiki.tsv           |
|       18 | lgwiki.tsv           |
|    77088 | bswiki.tsv           |
|    22152 | mlwiki.tsv           |
|    44652 | astwiki.tsv          |
|        1 | sgwiki.tsv           |
|      146 | nywiki.tsv           |
|    30223 | hrwiki.tsv           |
|      204 | chrwiki.tsv          |
|    53673 | fawiki.tsv           |
|    33645 | bnwiki.tsv           |
|      149 | emlwiki.tsv          |
|        9 | rmywiki.tsv          |
|     1272 | sahwiki.tsv          |
|      124 | krcwiki.tsv          |
|      104 | iewiki.tsv           |
|    46668 | tawiki.tsv           |
|    33638 | hiwiki.tsv           |
|      100 | kvwiki.tsv           |
|      974 | test2wiki.tsv        |
|        2 | arcwiki.tsv          |
|     2284 | cewiki.tsv           |
|        4 | kswiki.tsv           |
|      324 | vecwiki.tsv          |
|      243 | tswiki.tsv           |
|        2 | lbewiki.tsv          |
|   528783 | ruwiki.tsv           |
|      590 | fowiki.tsv           |
|       41 | hakwiki.tsv          |
|     1738 | kuwiki.tsv           |
|       74 | lrcwiki.tsv          |
|      172 | omwiki.tsv           |
|      180 | szlwiki.tsv          |
|    26773 | afwiki.tsv           |
|        1 | iiwiki.tsv           |
|    10185 | ndswiki.tsv          |
|     3164 | iswiki.tsv           |
|       14 | kaawiki.tsv          |
|      183 | tyvwiki.tsv          |
|    71036 | rowiki.tsv           |
|      140 | sewiki.tsv           |
|      111 | vepwiki.tsv          |
|     5755 | urwiki.tsv           |
|     4216 | fywiki.tsv           |
|      889 | newwiki.tsv          |
|      183 | snwiki.tsv           |
|      170 | yiwiki.tsv           |
|      335 | bclwiki.tsv          |
|        1 | ngwiki.tsv           |
| 15694032 | total                |
|----------|----------------------|
238482n375 removed bmansurov as the assignee of this task.Jun 15 2018, 8:03 AM
238482n375 lowered the priority of this task from Low to Lowest.
238482n375 moved this task from Next Up to In Code Review on the Analytics-Kanban board.
238482n375 edited subscribers, added: bmansurov, 238482n375; removed: Aklapper.

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